#property copyright ""
#property link      ""

#property indicator_chart_window

extern int vollbf = 30;
extern int spdlbf = 30;
extern int lookbackbars = 3000;
extern color strength_color = CornflowerBlue;
extern color weakness_color = IndianRed;
extern color wrong_background = Black;
extern int     ActiveSessionStart     = 10;    // Start time of Active session in brokers time 
extern int     ActiveSessionEnd       = 18;    // End time of Active session in brokers time

// weakness
int END_OF_RISING_MARKET        = 0; 
int NO_DEMAND_MKT_TOP           = 1; 
int EFFORT                      = 2; 
int UPTHRUST                    = 3; 
int NO_DEMAND_DOWNTREND         = 4; 
int WIDE_SPREAD_DOWN_BAR        = 5; 
int BUYING_CLIMAX               = 6; 
int TOP_REVERSAL	              = 7; 

//strength
int BOTTOM_REVERSAL             = 8;
int STOPPING_VOLUME             = 9; 
int TEST_OF_SUPPLY              = 10;
int WIDE_SPREAD_UP_BAR	        = 11;
int BAG_HOLDING                 = 12;
int SELLING_CLIMAX              = 13;
int SHAKEOUT                    = 14; 
int NO_SUPPLY                   = 15;

// bar type
bool upbar, downbar, upclose, midclose, downclose;
// spread
bool narrowsp, avgsp, widesp;
// volume
bool vlowv, lowv, avgv, highv, vhighv;
// previous bar up and down flags
bool pbarup, pbardown;
bool testmode = true;
int signal, prevsignal = EMPTY_VALUE;
int confirmsignal;

// signal codes  0   1   2   3   4   5   6   7 /  8   9  10  11  12  13  14  15 
int code[17] = {108,250,119,159,167,111,83,178,  178,108,167,111,108,83,159,250};
string text[17] = {"END OF RISING MARKET","NO DEMAND MKT TOP","EFFORT","UPTHRUST","NO DEMAND DOWNTREND","WIDE SPREAD DOWN BAR","BUYING CLIMAX","TOP REVERSAL",  
                  "BOTTOM REVERSAL","STOPPING VOLUME","TEST OF SUPPLY","WIDE SPREAD UP BAR","BAG HOLDING","SELLING CLIMAX","SHAKEOUT","NO SUPPLY"};
                  
double pts, dprice, last_dprice;
int sctr, icolor = 0;

int strength = 1;
int weakness = -1;
int up = 1;
int down = -1;
int vperiod, speriod = 0;
int background, meter = 0;

double small_body_ratio = 0.3333;
double mid_body_ratio = 0.60;
double long_body_ratio = 0.80;

double shift = 0;

double v1,v2, spread, closelow, avgspread, avgvol, volume; 
string objprefix = "[VSA]";
int MailSent = -1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{  
   SetConstants();   
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
  for(int i=ObjectsTotal();i >= 0;i--)
  {
    if(StringSubstr(ObjectName(i),0,StringLen(objprefix))==objprefix)
    { ObjectDelete(ObjectName(i)); }
  }
 
//----
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{  
   //---- exit if not enough bars to calculate average volume or spread
   int period;
   if (vperiod > speriod) { period = vperiod; }
   else {period = speriod;}
   if(Bars<=period) { return(0); }
   
   int counted_bars=IndicatorCounted(); 
   if(counted_bars > 0) { counted_bars--; } 
   int i;
   if(counted_bars>=period) { i=Bars-counted_bars-1; }
   else { i=Bars-period-1; }
   
   //---- determine VSA signals
   if (i>lookbackbars) {i=lookbackbars;}
   
   while(i>0)
   { 
      DetermineBarCharacteristics(i); 
      signal = DetermineSignal(i);
      DetermineBackground(i);
      DisplaySignal(signal, i);
      prevsignal = signal;
      i--;
      confirmsignal(i+1);
   } 
   return(0);
}

double CalcRange(int bar, bool verify=false)
{
   int counter, n=0;
   double Range, AvgRange; 
   if (verify) n=1;
   AvgRange=0;
   for (counter=bar-n; counter<=bar+1;counter++)
   {
      AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
   }
   Range=AvgRange/2;
   return(Range);
}

void SetConstants()
{
   shift =(WindowPriceMax()-WindowPriceMin())/30;
   meter = 0;
   background = 0;
   switch (Period()) {
      case PERIOD_M1:
         vperiod = 480*vollbf;
         speriod = 480*spdlbf; 
         break;
      case PERIOD_M5:
         vperiod = 480*vollbf;
         speriod = 480*spdlbf; 
         break;
      case PERIOD_M15:
         vperiod = 480*vollbf;
         speriod = 480*spdlbf; 
         break;
      case PERIOD_M30:
         vperiod = 240*vollbf;
         speriod = 240*spdlbf; 
         break;      
      case PERIOD_H1:
         vperiod = 120*vollbf;
         speriod = 120*spdlbf;
         break;
      case PERIOD_H4:
         vperiod = 30*vollbf;
         speriod = 30*spdlbf;
         break;
      case PERIOD_D1:
         vperiod = 30*vollbf;
         speriod = 30*spdlbf;
         break;
      case PERIOD_W1:
         vperiod = 20*vollbf;
         speriod = 20*spdlbf;
         break;
      case PERIOD_MN1:
         vperiod = 20*vollbf;
         speriod = 20*spdlbf;
         break;
      default:
         vperiod = 25*vollbf;
         speriod = 25*spdlbf; 
   }
   if (testmode)
      Comment("vl=",vperiod," sl=",speriod);
}

int Session(datetime dt)
{
   int session = 0;
   int hour = TimeHour(dt);
   if ((hour >= ActiveSessionStart) && (hour <= ActiveSessionEnd)) { session = 1; }
   else { session = 2; }
   return (session);
}

double CalculateAverageSpread(int bar)
{
   double ts, s = 0;
   int i, c = 0;
   i = bar;
   while (i<=speriod)
   {
      if (Session(iTime(NULL,Period(),i)) == 1)
      {
         s = High[i]-Low[i];
         ts = ts+s;
         c++;
      }
      i++;
      if (i>speriod) { break; }
   }   
   return(ts/c);
}

double CalculateAverageVolume(int bar)
{
   double tv, v = 0;
   int i, c = 0;
   i = bar;
   while (i<=vperiod)
   {
      if (Session(iTime(NULL,Period(),i)) == 1)
      {
         v = iVolume(NULL,Period(),i);
         tv = tv+v;
         c++;
      }
      i++;
      if (i>vperiod) { break; }
   }  
   return(tv/c);
} 

bool LocalHigh(int bar, int back)
{
   if (bar == iHighest(NULL,0, MODE_HIGH,back,bar))
   { return(true); }
   return(false);
}

bool LocalLow(int bar, int back)
{
   if (bar == iLowest(NULL,0, MODE_LOW,back,bar))
   {  return(true); }
   return(false);

}

bool upbar(int b, int n)
{
   if (Close[b] > Close[b+n])
   { return (true); }
   return (false);
}

bool downbar(int b, int n)
{
   if (Close[b] < Close[b+n])
   { return (true); }
   return (false);
}

int confirmsignal (int bar)
{
   if (((signal == EFFORT) || (signal == BUYING_CLIMAX)) &&  (Close[bar-1] > Close[bar])) { background = strength; meter = 1; }
   if (((signal == SELLING_CLIMAX) || (signal == TEST_OF_SUPPLY) || (signal == BAG_HOLDING) || (signal == SHAKEOUT)) &&  (Close[bar-1] < Close[bar])) { background = weakness; meter = -1; }
}

void DetermineBarCharacteristics(int bar)
{
   signal = EMPTY_VALUE;
// close
   upclose = false;
   midclose = false;
   downclose = false;

// bar type
   upbar = false;
   downbar = false;

//previous bar type
   pbarup = false;
   pbardown = false;

// spread
   narrowsp = false;
   avgsp = false;
   widesp = false;

// volume
   vlowv = false;
   lowv = false;
   avgv = false;
   highv = false;
   vhighv = false; 
   
   v1 = iVolume(NULL, Period(), bar+1);
   v2 = iVolume(NULL, Period(), bar+2);
   spread = MathAbs(High[bar]-Low[bar]);
   closelow = Close[bar]-Low[bar];
   
   avgspread = CalculateAverageSpread(bar);
   
   avgvol = CalculateAverageVolume(bar);
   volume = iVolume(NULL,Period(),bar);
   
   // is up bar or down bar
   if (Close[bar] > Close[bar+1]){ upbar = true; }
   else { downbar = true; }
    
   if (Close[bar+1] > Close[bar+2]) { pbarup = true; }
   else { pbardown = true; }
       
   // up close, mid close or down close bar
   if (spread>0) 
   { 
      if ((closelow/spread >= 0.3333) && (closelow/spread <= 0.6666))  { midclose = true; }
      else if (closelow/spread > 0.6666)  { upclose = true; }
      else { downclose = true; }
   }

   // determine category for bar's spread  
   if (spread <= avgspread*0.6666)  { narrowsp = true; }
   else if (spread > avgspread*0.6666 && spread <= avgspread*1.3333)  { avgsp = true; }
   else { widesp = true; }
   
   // determine category for bar's volume
   if ( volume <= (avgvol*0.40) ) { vlowv = true; }
   else if ( volume > (avgvol*0.40) && volume <= (avgvol*0.80)) { lowv = true;  }
   else if ( volume > (avgvol*0.80) && volume <= (avgvol*1.20)) { avgv = true; }
   else if ( volume > (avgvol*1.20) && volume <= (avgvol*1.60)) { highv = true; }
   else { vhighv = true; }
}

void DetermineBackground(int bar)
{
   if (bar==0){return;}
 
   //weakness  
   if ((signal == BUYING_CLIMAX) || (signal == TOP_REVERSAL) || (signal == END_OF_RISING_MARKET) || (signal == UPTHRUST) || (signal == EFFORT)) { background = weakness; meter = -1; } 
   
   // strength
   if ((signal == WIDE_SPREAD_UP_BAR) || (signal == STOPPING_VOLUME) || (signal == SELLING_CLIMAX) || (signal == BOTTOM_REVERSAL) || (signal == BAG_HOLDING) || (signal == SHAKEOUT)) { background = strength; meter = 1; }
   
   // powerful concepts
   if (((prevsignal == BUYING_CLIMAX) || (prevsignal == END_OF_RISING_MARKET)) && ((signal == NO_DEMAND_DOWNTREND) || (signal == NO_DEMAND_MKT_TOP))) { meter = -1; }
   if ((prevsignal == SELLING_CLIMAX) && (signal == SHAKEOUT)) { meter = 1; }
   
   if ((meter < 1) && (meter > -1))
     { background = 0; }
   if (meter > 1) 
     { background = strength; }
   if (meter < -1)
     { background = weakness; }
}

int DetermineSignal(int bar)  // determine current VSA signal 
{    
   // body to spread information 
   double co_ratio, co1_ratio, oc_ratio, oc1_ratio;
   if (spread>0) 
   { 
      co_ratio = MathAbs(Close[bar]-Open[bar])/spread; 
      oc_ratio = MathAbs(Open[bar]-Close[bar])/spread;
      co1_ratio = MathAbs(Close[bar+1]-Open[bar+1])/spread;
      oc1_ratio = MathAbs(Open[bar+1]-Close[bar+1])/spread;
   } 
   else { co_ratio = 0.0; co1_ratio =0.0; oc_ratio = 0.0; oc1_ratio = 0.0; }

   // signs of WEAKNESS
   
   // end of a rising market 
   if (upbar && narrowsp && (midclose || downclose) && (highv || vhighv) && LocalHigh(bar, 10))
   { signal = END_OF_RISING_MARKET; }
   //NOTES: good to enter on ND or Upthrust - confirmation
   
   // no demand at market top
   if (upbar && narrowsp && (upclose || midclose || downclose) && (vlowv || lowv) && LocalHigh(bar,5))
   { signal = NO_DEMAND_MKT_TOP; } 
   //NOTES: good entry (if weakness in background) - confirmation
   
   //wide spread down bar through previous support
   if (downbar && widesp && downclose && (highv || vhighv) && LocalLow(bar,10) && (oc_ratio >= mid_body_ratio))
   { signal = WIDE_SPREAD_DOWN_BAR; }
   //NOTES: next bar has to close lower, enter on ND - continuation
      
   // effort
   if (upbar && widesp && upclose && (avgv || highv || vhighv) && LocalHigh(bar,5)
             && (co_ratio > mid_body_ratio)) // checking for open near high
   { signal = EFFORT; }
   //NOTES: need to check next bar if effort produced result - confirmation
   
   // buying climax
   if (upbar && widesp && (midclose || downclose) && vhighv && LocalHigh(bar,10) && (co_ratio >= mid_body_ratio) && upbar(bar+1,1))
   { signal = BUYING_CLIMAX; }
   //NOTES: enter on ND - background
   
   // upthrust
   if ((upbar || downbar) && (avgsp || widesp) && downclose && (avgv || highv || vhighv) && LocalHigh(bar,5) && (co_ratio <= small_body_ratio))
   { signal = UPTHRUST; }
   //NOTES: only in downtrend, added strength is breakout through downtrend channel - confirmation
   
   // no demand in downtrend
   if (upbar && narrowsp && (upclose || midclose || downclose) && ((volume<v1) && (volume<v2)))
   { signal = NO_DEMAND_DOWNTREND; } 
   //NOTES: powerful after buying climax or end of rising market - confirmation
   
   // top reversal   
   if ((Close[bar+1]>Open[bar+1]) && (Open[bar]>Close[bar]) && downbar && widesp && downclose && (avgv || highv || vhighv)
                                  && (oc_ratio > mid_body_ratio) && (co1_ratio > mid_body_ratio)&& LocalHigh(bar+1,5))
   { signal = TOP_REVERSAL; } 
   //NOTES: enter on ND or Upthrust - background
   
   // signs of STRENGTH
   
   // bottom reversal
   if ((Close[bar+1]<Open[bar+1]) && (Open[bar]<Close[bar]) && upbar && widesp && upclose && (avgv || highv || vhighv )
                                  && (co_ratio > mid_body_ratio) && (oc1_ratio > mid_body_ratio) && LocalLow(bar+1,5))
   { signal = BOTTOM_REVERSAL; }
   //NOTES: enter on NS or Test - background 
      
   // stopping volume
   if (downbar && narrowsp && (midclose || upclose) && vhighv && LocalLow(bar,10))
   { signal = STOPPING_VOLUME; }
   //NOTES: keep track of stopping level and wait to see if price tests on low volume - confirmation
   
   // test (of supply)
   if (downbar && narrowsp && (midclose || upclose) && ((vlowv || lowv) || ((volume < v1) && (volume < v2)))) 
   { signal = TEST_OF_SUPPLY; } 
   //NOTES: entry at top of test bar - confirmation
      
   // wide spread up bar closing on highs (absorption)
   if (upbar && widesp && upclose && vhighv && LocalHigh(bar,10) && (co_ratio >= mid_body_ratio))
   { signal = WIDE_SPREAD_UP_BAR; }
   //NOTES: entry above absorption bar - continuation
   
   // bag holding
   if (downbar && avgsp && (midclose || upclose) && vhighv && LocalLow(bar,10))
   { signal = BAG_HOLDING; }
   //NOTES: entry on test - background
   
   // selling climax
   if (downbar && widesp && (midclose || upclose) && (highv || vhighv) && LocalLow(bar,10) && downbar(bar+1,1)) 
   { signal = SELLING_CLIMAX; }
   //NOTES: entry on test - background
   
   // shakeout   
   if (downbar && widesp && (midclose || downclose) && (highv || vhighv) && LocalLow(bar,5) && (co_ratio > 0.5))
   { signal = SHAKEOUT; }
   //NOTES: entry on test - confirmation
   
   // no supply       
   if (downbar && narrowsp && midclose && ((vlowv || lowv) || ((volume < v1) && (volume < v2))))
   { signal = NO_SUPPLY; }
   //NOTES: entry on top of NS bar, uptrend - confirmation

   //testmode
   if (testmode && bar == 2) // set the bar number to inspect the values and confirm against signals criteria
   {
      string t = "Bar ="+DoubleToStr(bar,0)+" signal= "+DoubleToStr(signal,0)+"\n";
      t= t+"spread - ns:"+DoubleToStr(narrowsp,0)+" avgsb:"+DoubleToStr(avgsp,0)+" wsb:"+DoubleToStr(widesp,0)+"\n";
      t= t+"bar type - downbar:"+DoubleToStr(downbar,0)+" upbar:"+DoubleToStr(upbar,0)+" pbarup:"+DoubleToStr(pbarup,0)+" pbardown:"+DoubleToStr(pbardown,0)+" upclose:"+DoubleToStr(upclose,0)+" downclose:"+DoubleToStr(downclose,0)+" midclose:"+DoubleToStr(midclose,0)+"\n";
      t= t+"vol - vl:"+DoubleToStr(vlowv,0)+" l:"+DoubleToStr(lowv,0)+" a:"+DoubleToStr(avgv,0)+" high:"+DoubleToStr(highv,0)+" vhigh:"+DoubleToStr(vhighv,0)+"\n";
      t= t+"Volume:"+DoubleToStr(volume,0)+" v1:"+DoubleToStr(v1,0)+" v2:"+DoubleToStr(v2,0)+" avgvol:"+DoubleToStr(avgvol,0)+"\n";
      t= t+"LocalHigh(5):" + LocalHigh(bar,5) + " LocalLow(5):" + LocalLow(bar,5)+"\n";
      t= t+"LocalHigh(15):" + LocalHigh(bar,15) + " LocalLow(15):" + LocalLow(bar,15)+"\n";
      t= t+"Spread ="+DoubleToStr(spread,2)+" avgspread:"+DoubleToStr(avgspread,2)+"\n";
      t= t+"Background = "+DoubleToStr(background,0)+" Meter ="+DoubleToStr(meter,0);
      Comment(t);
   }   
   return(signal);
}

int DisplaySignal(int s, int bar)
{
   int hour = TimeHour(TimeCurrent());
   
   if (s==EMPTY_VALUE)
   { return(0);}
   
   icolor = wrong_background;  // if wrong background, show signal in gray
   if (s < 8) 
   { 
     dprice = High[bar] + 0.1*CalcRange(bar, false);
     if (background == weakness) // background weakness, signal weakness, mark with red
     { 
       if (hour >= 9 && hour <= 19)
       {
         if (bar == 1) 
         { 
           if( MailSent != Bars )
           {
           if (s == 0) { SendMail(" Alert ", "[" + Symbol() + "] " + "Weakness, End Rising Market"); }
           if (s == 1) { SendMail(" Alert ", "[" + Symbol() + "] " + "Weakness, No Demand Market Top"); }
           if (s == 2) { SendMail(" Alert ", "[" + Symbol() + "] " + "Weakness, Effort"); }
           if (s == 3) { SendMail(" Alert ", "[" + Symbol() + "] " + "Weakness, Upthrust"); }
           if (s == 4) { SendMail(" Alert ", "[" + Symbol() + "] " + "Weakness, No Demand Downtrend"); }
           if (s == 5) { SendMail(" Alert ", "[" + Symbol() + "] " + "Weakness, Wide Spread Down Bar"); }
           if (s == 6) { SendMail(" Alert ", "[" + Symbol() + "] " + "Weakness, Buying Climax"); }
           if (s == 7) { SendMail(" Alert ", "[" + Symbol() + "] " + "Weakness, Top Reversal"); }
           MailSent = Bars ; 
           }
         }
       }
     icolor = weakness_color; 
     }
   } 
   else 
   { 
     dprice = Low[bar] - 0.1*CalcRange(bar, false); 
     if (background == strength)  // background strength, signal strength, mark with blue
     { 
       if (hour >= 9 && hour <= 19)
       {
         if (bar == 1) 
         { 
           if( MailSent != Bars )
           {
           if (s == 8) { SendMail(" Alert ", "[" + Symbol() + "] " + "Strength, Bottom Reversal"); }
           if (s == 9) { SendMail(" Alert ", "[" + Symbol() + "] " + "Strength, Stopping Volume"); }
           if (s == 10) { SendMail(" Alert ", "[" + Symbol() + "] " + "Strength, Test Of Supply"); }
           if (s == 11) { SendMail(" Alert ", "[" + Symbol() + "] " + "Strength, Wide Spread Up Bar"); }
           if (s == 12) { SendMail(" Alert ", "[" + Symbol() + "] " + "Strength, Bag Holding"); }
           if (s == 13) { SendMail(" Alert ", "[" + Symbol() + "] " + "Strength, Selling Climax"); }
           if (s == 14) { SendMail(" Alert ", "[" + Symbol() + "] " + "Strength, Shakeout"); }
           if (s == 15) { SendMail(" Alert ", "[" + Symbol() + "] " + "Strength, No Supply"); }
           MailSent = Bars ; 
           }
         }
       }
     icolor = strength_color; 
     }
   }
   if (ObjectCreate(objprefix+" "+text[s]+" ("+bar+")", OBJ_ARROW, 0, Time[bar], dprice) == true)
   {
      ObjectSet(objprefix+" "+text[s]+" ("+bar+")", OBJPROP_ARROWCODE, code[s]);     
      ObjectSet(objprefix+" "+text[s]+" ("+bar+")", OBJPROP_COLOR, icolor);
      SetIndexArrow(3,code[s]);
      sctr++; 
   }
   return(0);
}

//+------------------------------------------------------------------+